'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getAboutInformation = getAboutInformation;

var _winston = require('winston');

var _winston2 = _interopRequireDefault(_winston);

var _utils = require('../utils');

var utils = _interopRequireWildcard(_utils);

var _package = require('../../package.json');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

async function getAboutInformation(ctx) {
  try {
    ctx.body = { currentCoreVersion: _package.version, serverTimezone: utils.serverTimezone() };
    ctx.status = 200;
    _winston2.default.info(`User ${ctx.authenticated.email} successfully fetched 'about' information`);
  } catch (e) {
    utils.logAndSetResponse(ctx, 500, `Could not fetch 'about' info via the API ${e}`, 'error');
  }
}
//# sourceMappingURL=about.js.map