'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connectionATNA = exports.connectionDefault = exports.connectionAPI = undefined;

var _mongoose = require('mongoose');

var _mongoose2 = _interopRequireDefault(_mongoose);

var _ = require('./');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_.config.mongo = _.config.get('mongo');

const connectionAPI = exports.connectionAPI = _mongoose2.default.createConnection(_.config.mongo.url, getMongoOptions());
const connectionDefault = exports.connectionDefault = _mongoose2.default.createConnection(_.config.mongo.url);
const connectionATNA = exports.connectionATNA = _mongoose2.default.createConnection(_.config.mongo.atnaUrl);

function getMongoOptions() {
  return {
    db: {
      readPreference: _.config.mongo.openHIMApiReadPreference,
      readConcern: { level: _.config.mongo.openHIMApiReadConcern },
      w: _.config.mongo.openHIMApiWriteConcern
    }
  };
}
//# sourceMappingURL=connection.js.map