'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ContactGroupModel = exports.ContactGroupModelAPI = exports.ContactUserDef = undefined;

var _mongoose = require('mongoose');

var _config = require('../config');

const ContactUserDef = exports.ContactUserDef = {
  user: {
    type: String, required: true
  },
  method: {
    type: String, required: true, enum: ['email', 'sms']
  },
  maxAlerts: {
    type: String, enum: ['no max', '1 per hour', '1 per day'], default: 'no max'
  }
};

const ContactGroupSchema = new _mongoose.Schema({
  group: {
    type: String, required: true, unique: true
  },
  users: [ContactUserDef]
});

const ContactGroupModelAPI = exports.ContactGroupModelAPI = _config.connectionAPI.model('ContactGroup', ContactGroupSchema);
const ContactGroupModel = exports.ContactGroupModel = _config.connectionDefault.model('ContactGroup', ContactGroupSchema);
//# sourceMappingURL=contactGroups.js.map